/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.11.2.1 by adcroft, Wed Oct 1 18:44:48 2003 UTC revision 1.32 by edhill, Wed Nov 12 22:05:47 2003 UTC
# Line 11  Line 11 
11  # Search for particular CPP #cmds associated with packages  # Search for particular CPP #cmds associated with packages
12  # usage: test_for_package_in_cpp_options CPP_file package_name  # usage: test_for_package_in_cpp_options CPP_file package_name
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14     cpp_options=$1      cpp_options=$1
15     pkg=$2      pkg=$2
16     grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1
17     RETVAL=$?      RETVAL=$?
18     if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
19        echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"
20        exit 99          exit 99
21     fi      fi
22     grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1
23     RETVAL=$?      RETVAL=$?
24     if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
25        echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"
26        exit 99          exit 99
27     fi      fi
28     grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1
29     RETVAL=$?      RETVAL=$?
30     if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
31        echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"
32        exit 99          exit 99
33     fi      fi
34     grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1
35     RETVAL=$?      RETVAL=$?
36     if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
37        echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"          echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"
38        exit 99          exit 99
39     fi     fi
40  }  }
41    
42    # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
43    # the package list.
44    expand_pkg_groups() {
45        new_packages=
46        PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
47        if test -r $PKG_GROUPS ; then
48            cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
49            cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
50            matched=0
51            for i in $PACKAGES ; do
52                line=`grep "^ *$i" ./p2.tmp`
53                RETVAL=$?
54                if test "x$RETVAL" = x0 ; then
55                    matched=1
56                    replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`
57                    echo "    replacing \"$i\" with: $replace"
58                    new_packages="$new_packages $replace"
59                else
60                    new_packages="$new_packages $i"
61                fi
62            done
63            PACKAGES=$new_packages
64            rm -f ./p[1,2].tmp
65        else
66            echo "Warning: can't read package groups definition file: $PKG_GROUPS"
67        fi
68    }
69    
70  # Guess possible config options for this host  # Guess possible config options for this host
71  find_possible_configs()  {  find_possible_configs()  {
72    
73      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
74      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
75      PLATFORM=`echo $tmp2 | sed -e 's/i[3-6]86/ia32/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
76        PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
77      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
78      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
79  #     if test "x$OFLIST" = x ; then  #     if test "x$OFLIST" = x ; then
# Line 77  find_possible_configs()  { Line 105  find_possible_configs()  {
105      fi      fi
106    
107      # look for possible fortran compilers      # look for possible fortran compilers
108      tmp="$MITGCM_FC $FC g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
109      p_FC=      p_FC=
110      for c in $tmp ; do      for c in $tmp ; do
111          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 94  EOF Line 122  EOF
122              p_FC="$p_FC $c"              p_FC="$p_FC $c"
123          fi          fi
124      done      done
125        rm -f ./hello.f ./hello
126      if test "x${p_FC}" = x ; then      if test "x${p_FC}" = x ; then
127          cat 1>&2 <<EOF          cat 1>&2 <<EOF
128    
# Line 109  EOF Line 138  EOF
138          echo "  The possible FORTRAN compilers found in your path are:"          echo "  The possible FORTRAN compilers found in your path are:"
139          echo "   "$p_FC          echo "   "$p_FC
140          if test "x$FC" = x ; then          if test "x$FC" = x ; then
141              FC=`echo $p_FC | awk '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
142          fi          fi
143      fi      fi
144    
# Line 175  get_pdepend_list()  { Line 204  get_pdepend_list()  {
204      #  strip the comments and then convert the dependency file into      #  strip the comments and then convert the dependency file into
205      #  two arrays: PNAME, DNAME      #  two arrays: PNAME, DNAME
206      cat $1 | sed -e 's/#.*$//g' \      cat $1 | sed -e 's/#.*$//g' \
207          | awk 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
208          > ./.pd_tmp          > ./.pd_tmp
209      source ./.pd_tmp      source ./.pd_tmp
210      rm -f ./.pd_tmp      rm -f ./.pd_tmp
# Line 212  usage()  { Line 241  usage()  {
241      echo "      -disable=NAME | --disable=NAME"      echo "      -disable=NAME | --disable=NAME"
242      echo "    -enable NAME | --enable NAME"      echo "    -enable NAME | --enable NAME"
243      echo "      -enable=NAME | --enable=NAME"      echo "      -enable=NAME | --enable=NAME"
244        echo "    -standarddirs NAME | --standarddirs NAME"
245        echo "      -standarddirs=NAME | --standarddirs=NAME"
246      echo "    -noopt NAME | --noopt NAME"      echo "    -noopt NAME | --noopt NAME"
247      echo "      -noopt=NAME | --noopt=NAME"      echo "      -noopt=NAME | --noopt=NAME"
248  #    echo "    -cpp NAME | --cpp NAME"  #    echo "    -cpp NAME | --cpp NAME"
# Line 233  usage()  { Line 264  usage()  {
264      exit 1      exit 1
265  }  }
266    
267  #eh3 # This is the generic configuration.  #  Build a CPP macro to automate calling C routines from FORTRAN
268  #eh3 set LN         = ( 'ln -s' )  get_fortran_c_namemangling()  {
269  #eh3 set CPP        = ( '/lib/cpp -P' )      default_nm="#define FC_NAMEMANGLE(X) X ## _"
270  #eh3 set S64        = ( '$(TOOLSDIR)/set64bitConst.sh' )      
271  #eh3 set KPP        = (  )      cat > genmake_test.c <<EOF
272  #eh3 set FC         = ( 'f77' )  void tcall( char * string ) { tsub( string ); }
273  #eh3 set LINK       = $FC  EOF
274  #eh3 set MAKEDEPEND = ( 'makedepend' )      $MAKE genmake_test.o > genmake_test.log 2>&1
275  #eh3 set INCLUDES   = ( -I. )      RETVAL=$?
276  #eh3 set FFLAGS     = (  )      if test "x$RETVAL" != x0 ; then
277  #eh3 set FOPTIM     = (  )          cat genmake_test.log >> genmake_errors
278  #eh3 set CFLAGS     = (  )          FC_NAMEMANGLE=$default_nm
279  #eh3 set KFLAGS1    = (  )          echo
280  #eh3 set KFLAGS2    = (  )          echo "WARNING: C test compile fails -- please see \"genmake_errors\""
281  #eh3 set LIBS       = (  )          echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"
282  #eh3 set KPPFILES   = (  )          echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."
283  #eh3 if (! $?NOOPTFILES ) set NOOPTFILES = (  )          return 1
284  #eh3 if (! $?NOOPTFLAGS ) set NOOPTFLAGS = (  )      fi
285        c_tcall=`nm genmake_test.o | grep tcall | cut -d ' ' -f 3`
286        RETVAL=$?
287        if test "x$RETVAL" != x0 ; then
288            FC_NAMEMANGLE=$default_nm
289            echo
290            echo "WARNING: The \"nm\" command failed."
291            echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"
292            echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."
293            return 1
294        fi
295        cat > genmake_tcomp.f <<EOF
296          subroutine tcall( string )
297          character*(*) string
298          call tsub( string )
299          end
300    EOF
301        $FC $FFLAGS $DEFINES -c genmake_tcomp.f > genmake_tcomp.log 2>&1
302        RETVAL=$?
303        if test "x$RETVAL" != x0 ; then
304            cat genmake_tcomp.log >> genmake_errors
305            FC_NAMEMANGLE=$default_nm
306            echo
307            echo "WARNING: FORTRAN test compile fails -- please see \"genmake_errors\""
308            echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"
309            echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."
310            return 1
311        fi
312        f_tcall=`nm genmake_tcomp.o | grep tcall | cut -d ' ' -f 3`
313        RETVAL=$?
314        if test "x$RETVAL" != x0 ; then
315            FC_NAMEMANGLE=$default_nm
316            echo
317            echo "WARNING: The \"nm\" command failed."
318            echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"
319            echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."
320            return 1
321        fi
322    
323        c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
324        f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
325        c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
326        f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
327    
328        nmangle="X"
329        if test "x$c_a" != "x$f_a" ; then
330            comm="echo x$f_a | sed -e 's|x$c_a||'"
331            a=`eval $comm`
332            nmangle="$a ## $nmangle"
333        fi
334        if test "x$c_b" != "x$f_b" ; then
335            comm="echo x$f_b | sed -e 's|x$c_b||'"
336            b=`eval $comm`
337            nmangle="$nmangle ## $b"
338        fi
339    
340        FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmangle"
341    
342        #  cleanup the testing files
343        rm -f genmake_tcomp.* genmake_test.*
344    }
345    
346  #  Set defaults here  #  Set defaults here
347  COMMANDL="$0 $@"  COMMANDL="$0 $@"
# Line 261  S64= Line 352  S64=
352  KPP=  KPP=
353  FC=  FC=
354  LINK=  LINK=
355  DEFINES="-DWORDLENGTH=4"  # DEFINES="-DWORDLENGTH=4"
356    DEFINES=
357  PACKAGES=  PACKAGES=
358  ENABLE=  ENABLE=
359  DISABLE=  DISABLE=
# Line 282  KPPFILES= Line 374  KPPFILES=
374  NOOPTFILES=  NOOPTFILES=
375  NOOPTFLAGS=  NOOPTFLAGS=
376    
377    # DEFINES checked by test compilation
378    HAVE_SYSTEM=
379    HAVE_FDATE=
380    FC_NAMEMANGLE=
381    
382  MODS=  MODS=
383  TOOLSDIR=  TOOLSDIR=
384  SOURCEDIRS=  SOURCEDIRS=
385  INCLUDEDIRS=  INCLUDEDIRS=
386    STANDARDDIRS=
387    
388  PWD=`pwd`  PWD=`pwd`
389  MAKE=make  MAKE=make
390    AWK=awk
391  THISHOSTNAME=`hostname`  THISHOSTNAME=`hostname`
392  THISCWD=`pwd`  THISCWD=`pwd`
393  THISDATE=`date`  THISDATE=`date`
# Line 296  MACHINE=`uname -a` Line 395  MACHINE=`uname -a`
395  EXECUTABLE=  EXECUTABLE=
396  EXEHOOK=  EXEHOOK=
397  EXEDIR=  EXEDIR=
398    PACKAGES_CONF=
399    IEEE=
400    if test "x$MITGCM_IEEE" != x ; then
401        IEEE=$MITGCM_IEEE
402    fi
403    
404    AUTODIFF_PKG_USED=f
405    AD_OPTFILE=
406    TAF=
407    AD_TAF_FLAGS=
408    FTL_TAF_FLAGS=
409    SVD_TAF_FLAGS=
410    TAF_EXTRA=
411    TAMC=
412    AD_TAMC_FLAGS=
413    FTL_TAF_FLAGS=
414    SVD_TAMC_FLAGS=
415    TAMC_EXTRA=
416    
417    
418  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
419  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"
420  gm_s2="FC IEEE MPI JAM DUMPSTATE"  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"
421    
422  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
423  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
424  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
425  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
426  gm_s6="EXECUTABLE EXEHOOK EXEDIR"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
427    gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"
428    
429  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6"  #  The following are all related to adjoint/tangent-linear stuff
430    gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
431    gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
432    gm_s12="TAF_EXTRA TAMC_EXTRA"
433    
434    gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
435    gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
436    
437    
438  echo  echo
439  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
440  gm_local="./gm_local"  gm_local="genmake_local"
441    for i in . $MODS ; do
442        if test -r $i/$gm_local ; then
443            source $i/$gm_local
444            break
445        fi
446    done
447  echo -n "  getting local config information:  "  echo -n "  getting local config information:  "
448  if test -e $gm_local ; then  if test -e $gm_local ; then
449      echo "using $gm_local"      echo "using $gm_local"
# Line 334  fi Line 465  fi
465  #   n=$(( $n + 1 ))  #   n=$(( $n + 1 ))
466  #done  #done
467  #parse_options  #parse_options
   
468  ac_prev=  ac_prev=
469  for ac_option ; do  for ac_option ; do
470    
# Line 359  for ac_option ; do Line 489  for ac_option ; do
489          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
490              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
491                    
492            -adoptfile | --adoptfile | -ad | --ad)
493                ac_prev=AD_OPTFILE ;;
494            -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
495                AD_OPTFILE=$ac_optarg ;;
496            
497          -pdepend | --pdepend)          -pdepend | --pdepend)
498              ac_prev=PDEPEND ;;              ac_prev=PDEPEND ;;
499          -pdepend=* | --pdepend=*)          -pdepend=* | --pdepend=*)
# Line 404  for ac_option ; do Line 539  for ac_option ; do
539          -enable=* | --enable=*)          -enable=* | --enable=*)
540              ENABLE=$ac_optarg ;;              ENABLE=$ac_optarg ;;
541                    
542            -standarddirs | --standarddirs)
543                ac_prev=STANDARDDIRS ;;
544            -standarddirs=* | --standarddirs=*)
545                STANDARDDIRS=$ac_optarg ;;
546    
547          -noopt | --noopt)          -noopt | --noopt)
548              ac_prev=NOOPT ;;              ac_prev=NOOPT ;;
549          -noopt=* | --noopt=*)          -noopt=* | --noopt=*)
# Line 420  for ac_option ; do Line 560  for ac_option ; do
560              FC=$ac_optarg ;;              FC=$ac_optarg ;;
561                    
562          -ieee | --ieee)          -ieee | --ieee)
563              IEEE=1 ;;              IEEE=true ;;
564          -noieee | --noieee)          -noieee | --noieee)
565              IEEE=0 ;;              IEEE= ;;
566                    
567          -mpi | --mpi)          -mpi | --mpi)
568              MPI=1 ;;              MPI=true ;;
569          -nompi | --nompi)          -nompi | --nompi)
570              MPI=0 ;;              MPI= ;;
571                    
572          -jam | --jam)          -jam | --jam)
573              JAM=1 ;;              JAM=1 ;;
# Line 437  for ac_option ; do Line 577  for ac_option ; do
577          -ds | --ds)          -ds | --ds)
578              DUMPSTATE=t ;;              DUMPSTATE=t ;;
579                    
580            -taf_extra | --taf_extra)
581                ac_prev=TAF_EXTRA ;;
582            -taf_extra=* | --taf_extra=*)
583                TAF_EXTRA=$ac_optarg ;;
584    
585            -tamc_extra | --tamc_extra)
586                ac_prev=TAMC_EXTRA ;;
587            -tamc_extra=* | --tamc_extra=*)
588                TAMC_EXTRA=$ac_optarg ;;
589    
590          -*)          -*)
591              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
592              usage              usage
# Line 451  for ac_option ; do Line 601  for ac_option ; do
601            
602  done  done
603    
604    if test -f ./.genmakerc ; then
605        echo
606        echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
607        echo "  file.  This file format is no longer supported.  Please see:"
608        echo
609        echo "    http://mitgcm.org/devel_HOWTO/"
610        echo
611        echo "  for directions on how to setup and use the new \"genmake2\" input"
612        echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."
613        echo
614    fi
615    
616  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
617      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
618          ROOTDIR=".."          ROOTDIR=".."
# Line 497  if test "x$OPTFILE" != xNONE ; then Line 659  if test "x$OPTFILE" != xNONE ; then
659              exit 1              exit 1
660          fi          fi
661          if test "x$DUMPSTATE" != xf ; then          if test "x$DUMPSTATE" != xf ; then
662              cp -f $OPTFILE "gm_optfile"              cp -f $OPTFILE "genmake_optfile"
663          fi          fi
664      else      else
665          echo "Error: can't read OPTFILE=\"$OPTFILE\""          echo "Error: can't read OPTFILE=\"$OPTFILE\""
# Line 505  if test "x$OPTFILE" != xNONE ; then Line 667  if test "x$OPTFILE" != xNONE ; then
667      fi      fi
668  fi  fi
669    
670    echo "  getting AD_OPTFILE information:  "
671    if test "x${AD_OPTFILE}" = x ; then
672        if test "x$MITGCM_AD_OF" = x ; then
673            AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
674        else
675            AD_OPTFILE=$MITGCM_AD_OF
676        fi
677    fi
678    if test "x${AD_OPTFILE}" != xNONE ; then
679        if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
680            echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
681            source "$AD_OPTFILE"
682            RETVAL=$?
683            if test "x$RETVAL" != x0 ; then
684                echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
685                echo "--please check that variable syntax is bash-compatible"
686                exit 1
687            fi
688            if test "x$DUMPSTATE" != xf ; then
689                cp -f $AD_OPTFILE "genmake_ad_optfile"
690            fi
691        else
692            echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
693            exit 1
694        fi
695    fi
696    
697  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain
698  #  and abort!  #  and abort!
699  if test "x$FC" = x ; then  if test "x$FC" = x ; then
# Line 513  if test "x$FC" = x ; then Line 702  if test "x$FC" = x ; then
702  Error: no Fortran compiler: please specify using one of the following:  Error: no Fortran compiler: please specify using one of the following:
703    1) within the options file ("FC=...") as specified by "-of=OPTFILE"    1) within the options file ("FC=...") as specified by "-of=OPTFILE"
704    2) the "-fc=XXX" command-line option    2) the "-fc=XXX" command-line option
705    3) the "./gm_local" file    3) the "./genmake_local" file
706  EOF  EOF
707      exit 1      exit 1
708  fi  fi
# Line 523  fi Line 712  fi
712  if test "x$CPP" = x ; then  if test "x$CPP" = x ; then
713      CPP="cpp"      CPP="cpp"
714  fi  fi
715  echo "#define A a" | cpp > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
716  RETVAL=$?  RETVAL=$?
717  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
718      cat <<EOF 1>&2      cat <<EOF 1>&2
# Line 531  if test "x$RETVAL" != x0 ; then Line 720  if test "x$RETVAL" != x0 ; then
720  Error: C pre-processor "$CPP" failed the test case: please specify using:  Error: C pre-processor "$CPP" failed the test case: please specify using:
721    
722    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
723    2) the "./gm_local" file    2) the "./genmake_local" file
724      3) with the CPP environment variable
725    
726  EOF  EOF
727      exit 1      exit 1
# Line 542  if test "x$MAKEDEPEND" = x ; then Line 732  if test "x$MAKEDEPEND" = x ; then
732      MAKEDEPEND=makedepend      MAKEDEPEND=makedepend
733  fi  fi
734    
735    
736    printf "\n===  Checking system libraries  ===\n"
737    echo -n "  Do we have the system() command using $FC...  "
738    cat > genmake_tcomp.f <<EOF
739          program hello
740          call system('echo hi')
741          end
742    EOF
743    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
744    RETVAL=$?
745    if test "x$RETVAL" = x0 ; then
746        HAVE_SYSTEM=t
747        DEFINES="$DEFINES -DHAVE_SYSTEM"
748        echo "yes"
749    else
750        HAVE_SYSTEM=
751        echo "no"
752    fi
753    rm -f genmake_tcomp*
754    
755    echo -n "  Do we have the fdate() command using $FC...  "
756    cat > genmake_tcomp.f <<EOF
757          program hello
758          CHARACTER(128) string
759          string = ' '
760          call fdate( string )
761          print *, string
762          end
763    EOF
764    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
765    RETVAL=$?
766    if test "x$RETVAL" = x0 ; then
767        HAVE_FDATE=t
768        DEFINES="$DEFINES -DHAVE_FDATE"
769        echo "yes"
770    else
771        HAVE_FDATE=
772        echo "no"
773    fi
774    rm -f genmake_tcomp*
775    
776    echo "  The name mangling convention for $FC is...  "
777    #FC_NAMEMANGLE="#define FC_NAMEMANGLE(X) X ## _"
778    if test "x$FC_NAMEMANGLE" = x ; then
779        get_fortran_c_namemangling
780    fi
781    echo "    '$FC_NAMEMANGLE'"
782    echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template
783    cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1
784    RETVAL=$?
785    if test "x$RETVAL" != x0 ; then
786        mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h
787    fi
788    
789    
790  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
791  echo -n "  Adding MODS directories:  "  echo -n "  Adding MODS directories:  "
792  for d in $MODS ; do  for d in $MODS ; do
# Line 624  echo "  getting package dependency info Line 869  echo "  getting package dependency info
869  #  Strip the comments and then convert the dependency file into  #  Strip the comments and then convert the dependency file into
870  #  two arrays: PNAME, DNAME  #  two arrays: PNAME, DNAME
871  cat $PDEPEND | sed -e 's/#.*$//g' \  cat $PDEPEND | sed -e 's/#.*$//g' \
872      | awk 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \      | $AWK 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \
873      > ./.pd_tmp      > ./.pd_tmp
874  RETVAL=$?  RETVAL=$?
875  if test ! "x${RETVAL}" = x0 ; then  if test ! "x${RETVAL}" = x0 ; then
# Line 634  fi Line 879  fi
879  source ./.pd_tmp  source ./.pd_tmp
880  rm -f ./.pd_tmp  rm -f ./.pd_tmp
881    
882    #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
883    #  file should eventually be added so that, for convenience, one can
884    #  specify groups of packages using names like "ocean" and "atmosphere".
885  echo  -n "  checking default package list:  "  echo  -n "  checking default package list:  "
886  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
887        for i in "." $MODS ; do
888            if test -r $i"/packages.conf" ; then
889                    PDEFAULT=$i"/packages.conf"
890                    break
891            fi
892        done
893    fi
894    if test "x${PDEFAULT}" = x ; then
895      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
896  fi  fi
897  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
# Line 647  else Line 903  else
903      else      else
904          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "  using PDEFAULT=\"$PDEFAULT\""
905          #  Strip the comments and add all the names          #  Strip the comments and add all the names
906          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | awk '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
907          RETVAL=$?          RETVAL=$?
908          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
909              echo -n "Error: can't parse default package list "              echo -n "Error: can't parse default package list "
# Line 657  else Line 913  else
913          for i in $def ; do          for i in $def ; do
914              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
915          done          done
916          echo "    packages are:  $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
917            expand_pkg_groups
918            echo "    after group expansion packages are:  $PACKAGES"
919      fi      fi
920  fi  fi
921    
# Line 767  for i in $PACKAGES ; do Line 1025  for i in $PACKAGES ; do
1025      if test -d $adr ; then      if test -d $adr ; then
1026          SOURCEDIRS="$SOURCEDIRS $adr"          SOURCEDIRS="$SOURCEDIRS $adr"
1027          INCLUDEDIRS="$INCLUDEDIRS $adr"          INCLUDEDIRS="$INCLUDEDIRS $adr"
1028            if test "x$i" = xautodiff ; then
1029                AUTODIFF_PKG_USED=t
1030            fi
1031      else      else
1032          echo "Error: the directory \"$adr\" for package $i doesn't exist"          echo "Error: the directory \"$adr\" for package $i doesn't exist"
1033          exit 1          exit 1
1034      fi      fi
1035  done  done
1036    
 #  This is compatible with the old genmake.  The "DISABLE_*" flags  
 #  need to be replaced by the "ALLOW_*" flags set below.  
 #  
 # echo -n "  Setting package-specific CPP flags:  "  
 # pkrm=( mom_fluxform mom_vecinv generic_advdiff )  
 # pkrmdef=( -DDISABLE_MOM_FLUXFORM -DDISABLE_MOM_VECINV -DDISABLE_GENERIC_ADVDIFF -DDISABLE_DEBUGMODE )  
 # echo -n "  "  
 # i=0  
 # while test $i -lt "${#pkrm[@]}" ; do  
 #     echo "$PACKAGES" | grep "${pk[$i]}" > /dev/null 2>&1  
 #     RETVAL=$?  
 #     if test "x$RETVAL" = x1 ; then  
 #       DEFINES="$DEFINES ${pkdef[$i]}"  
 #       echo -n " ${pkdef[$i]}"  
 #     fi  
 #     i=$(( $i + 1 ))  
 # done  
 # echo  
1037    
1038  # Create a list of #define and #undef to enable/disable packages  # Create a list of #define and #undef to enable/disable packages
1039  PACKAGES_DOT_H=PACKAGES.h  PACKAGES_DOT_H=PACKAGES_CONFIG.h
1040  if test -e $PACKAGES_DOT_H ; then  cat <<EOF >$PACKAGES_DOT_H".tmp"
     if test ! -e $PACKAGES_DOT_H.bak ; then  
         cp -f $PACKAGES_DOT_H $PACKAGES_DOT_H.bak  
     fi  
     cat $PACKAGES_DOT_H \  
         | awk 'BEGIN{p=1;} ($1=="C===" && $2=="GENMAKE"){p=0;} {if (p==1) print $0}' \  
         > $PACKAGES_DOT_H.tmp  
 fi  
 cat <<EOF >>$PACKAGES_DOT_H.tmp  
1041  C=== GENMAKE v2 ===  C=== GENMAKE v2 ===
1042  C  The following defines have been set by GENMAKE, so please do not  C  The following defines have been set by GENMAKE, so please do not
1043  C  edit anything below these comments.  In general, you should  C  edit anything below these comments.  In general, you should
1044  C  add or remove packages by re-running genmake with different  C  add or remove packages by re-running genmake with different
1045  C  "-enable" and/or "-disable" options.  C  "-enable" and/or "-disable" options.
1046    
1047    #ifndef PACKAGES_H
1048    #define PACKAGES_H
1049    
1050  C  Packages disabled by genmake:  C  Packages disabled by genmake:
1051  EOF  EOF
1052  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
# Line 827  for n in $names ; do Line 1065  for n in $names ; do
1065              fi              fi
1066          done          done
1067          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1068              undef=`echo "ALLOW_$n" | awk '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1069              echo "#undef $undef" >> $PACKAGES_DOT_H.tmp              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"
 #           DEFINES="$DEFINES -U$undef"  
   
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
             case $n in  
                 mom_fluxform)  
                     DEFINES="$DEFINES -DDISABLE_MOM_FLUXFORM"  
                     ;;  
                 mom_vecinv)  
                     DEFINES="$DEFINES -DDISABLE_MOM_VECINV"  
                     ;;  
                 debug)  
                     DEFINES="$DEFINES -DDISABLE_DEBUGMODE"  
                     ;;  
             esac  
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
   
1070          fi          fi
1071      fi      fi
1072  done  done
1073  cat <<EOF >>$PACKAGES_DOT_H.tmp  cat <<EOF >>$PACKAGES_DOT_H".tmp"
1074    
1075  C  Packages enabled by genmake:  C  Packages enabled by genmake:
1076  EOF  EOF
1077  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1078      def=`echo "ALLOW_$i" | awk '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1079      echo "#define $def" >> $PACKAGES_DOT_H.tmp      echo "#define $def" >> $PACKAGES_DOT_H".tmp"
1080      DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
1081    
1082  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1083      case $i in      case $i in
1084          aim_v23)          aim_v23)
1085              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H.tmp              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"
1086              DEFINES="$DEFINES -DALLOW_AIM"              DEFINES="$DEFINES -DALLOW_AIM"
1087              echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"              echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"
1088              ;;              ;;
1089      esac      esac
1090  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1091    
1092  done  done
1093  mv -f $PACKAGES_DOT_H.tmp $PACKAGES_DOT_H  cat <<EOF >>$PACKAGES_DOT_H".tmp"
1094    
1095    #endif /* PACKAGES_H */
1096    EOF
1097    
1098    if test ! -f $PACKAGES_DOT_H ; then
1099        mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1100    else
1101        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1102        RETVAL=$?
1103        if test "x$RETVAL" = x0 ; then
1104            rm -f $PACKAGES_DOT_H".tmp"
1105        else
1106            mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
1107            mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1108        fi
1109    fi
1110    
1111  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1112  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1113  STANDARDDIRS=${STANDARDDIRS:-"eesupp model"}  if test "x$STANDARDDIRS" = x ; then
1114        STANDARDDIRS="eesupp model"
1115    fi
1116  for d in $STANDARDDIRS ; do  for d in $STANDARDDIRS ; do
1117      adr="$ROOTDIR/$d/src"      adr="$ROOTDIR/$d/src"
1118      if test ! -d $adr ; then      if test ! -d $adr ; then
# Line 892  for d in $STANDARDDIRS ; do Line 1132  for d in $STANDARDDIRS ; do
1132      fi      fi
1133  done  done
1134    
1135  echo "  Searching for CPP_OPTIONS.h (macros and flags for configuring the model):"  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"
1136    echo "    of \"#define ALLOW_PKGNAME\"-type statements:"
1137  CPP_OPTIONS=  CPP_OPTIONS=
1138  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1139  for i in $spaths ; do  for i in $spaths ; do
# Line 901  for i in $spaths ; do Line 1142  for i in $spaths ; do
1142      if test -f $try -a -r $try ; then      if test -f $try -a -r $try ; then
1143          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1144          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
 #aja    if test "x$i" != "x." ; then  
 #aja        cp -f $CPP_OPTIONS .  
 #aja    fi  
1145          break          break
1146      fi      fi
1147  done  done
# Line 918  for n in $names ; do Line 1156  for n in $names ; do
1156  done  done
1157    
1158    
1159    #  Here, we build the list of files to be "run through" the adjoint
1160    #  compiler.
1161    if test -f ./ad_files ; then
1162        rm -f ./ad_files
1163    fi
1164    echo "  Creating the list of files for the adjoint compiler."
1165    for i in $SOURCEDIRS ; do
1166        list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
1167        for j in $list_files ; do
1168            cat $i/$j >> ad_files
1169        done
1170    done
1171    
1172    cat <<EOF > adjoint_sed
1173    s/call adopen(/call adopen ( mythid,\\
1174         \&           /g
1175    s/call adclose(/call adclose( mythid,\\
1176         \&           /g
1177    s/call adread(/call adread ( mythid,\\
1178         \&           /g
1179    s/call adwrite(/call adwrite( mythid,\\
1180         \&           /g
1181    
1182    EOF
1183    
1184  echo  echo
1185  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1186  echo "  setting INCLUDES"  echo "  setting INCLUDES"
# Line 938  echo -n 'SRCFILES = '    > srclist.inc Line 1201  echo -n 'SRCFILES = '    > srclist.inc
1201  echo -n 'CSRCFILES = '   > csrclist.inc  echo -n 'CSRCFILES = '   > csrclist.inc
1202  echo -n 'F90SRCFILES = ' > f90srclist.inc  echo -n 'F90SRCFILES = ' > f90srclist.inc
1203  echo -n 'HEADERFILES = ' > hlist.inc  echo -n 'HEADERFILES = ' > hlist.inc
1204    echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc
1205  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1206  for d in $alldirs ; do  for d in $alldirs ; do
1207      deplist=      deplist=
1208      sfiles=`( cd $d; echo *.[h,c,F] )`      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
1209      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
1210      for sf in $sfiles ; do      for sf in $sfiles ; do
1211          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1212              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1213                  extn=`echo $sf | awk -F '.' '{print $NF}'`                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`
1214                  touch .links.tmp/$sf                  touch .links.tmp/$sf
1215                  deplist="$deplist $sf"                  deplist="$deplist $sf"
1216                  case $extn in                  case $extn in
# Line 966  for d in $alldirs ; do Line 1230  for d in $alldirs ; do
1230                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1231                          echo -n " $sf" >> hlist.inc                          echo -n " $sf" >> hlist.inc
1232                          ;;                          ;;
1233                        flow)
1234                            echo    " \\"  >> ad_flow_files.inc
1235                            echo -n " $sf" >> ad_flow_files.inc
1236                            ;;
1237                  esac                  esac
1238              fi              fi
1239          fi          fi
# Line 982  echo "" >> srclist.inc Line 1250  echo "" >> srclist.inc
1250  echo "" >> csrclist.inc  echo "" >> csrclist.inc
1251  echo "" >> f90srclist.inc  echo "" >> f90srclist.inc
1252  echo "" >> hlist.inc  echo "" >> hlist.inc
1253    echo "" >> ad_flow_files.inc
 echo $DEFINES  
1254    
1255  if test -e $MAKEFILE ; then  if test -e $MAKEFILE ; then
1256      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
# Line 997  echo "# by the command:" >> $MAKEFILE Line 1264  echo "# by the command:" >> $MAKEFILE
1264  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $@" >> $MAKEFILE
1265  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1266  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1267    
1268    EXE_AD=$EXECUTABLE"_ad"
1269    EXE_FTL=$EXECUTABLE"_ftl"
1270    EXE_SVD=$EXECUTABLE"_svd"
1271    
1272  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1273  #  #
1274  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
# Line 1025  EXEDIR      = ${EXEDIR} Line 1297  EXEDIR      = ${EXEDIR}
1297  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}
1298  TOOLSDIR    = ${TOOLSDIR}  TOOLSDIR    = ${TOOLSDIR}
1299    
1300    #eh3  new defines for the adjoint work
1301    AUTODIFF    = ${ROOTDIR}/pkg/autodiff
1302    EXE_AD      = ${EXE_AD}
1303    EXE_FTL     = ${EXE_FTL}
1304    EXE_SVD     = ${EXE_SVD}
1305    
1306  EOF  EOF
1307    
1308  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1070  MAKEFILE=${MAKEFILE} Line 1348  MAKEFILE=${MAKEFILE}
1348    
1349  EOF  EOF
1350    
1351  cat srclist.inc    >> $MAKEFILE  cat srclist.inc       >> $MAKEFILE
1352  cat csrclist.inc   >> $MAKEFILE  cat csrclist.inc      >> $MAKEFILE
1353  cat f90srclist.inc >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1354  cat hlist.inc      >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1355    cat ad_flow_files.inc >> $MAKEFILE
1356    echo               >> $MAKEFILE
1357  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE
1358  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE
1359  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1360    
1361  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1362    rm -f ad_flow_files.inc
1363    
1364  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1365    
# Line 1102  output.txt: \$(EXECUTABLE) Line 1383  output.txt: \$(EXECUTABLE)
1383          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1384    
1385  clean:  clean:
1386            -cat AD_CONFIG.template > AD_CONFIG.h
1387          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}
1388  Clean:  Clean:
1389          @make clean          @make clean
1390          @make cleanlinks          @make cleanlinks
1391          -rm -f Makefile.bak gm_state gm_optfile make.log PACKAGES.h*          -rm -f Makefile.bak genmake_state genmake_*optfile make.log
1392  CLEAN:  CLEAN:
1393          @make Clean          @make Clean
1394          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
# Line 1114  CLEAN: Line 1396  CLEAN:
1396          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1397          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt
1398    
1399    #eh3 Makefile: makefile
1400  makefile:  makefile:
1401          ${0} $@          ${0} $@
1402  cleanlinks:  cleanlinks:
# Line 1137  cleanlinks: Line 1420  cleanlinks:
1420  .p.f:  .p.f:
1421          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1422    
1423    #=========================================
1424    #===  Automatic Differentiation Rules  ===
1425    
1426    TAMC           = ${TAMC}
1427    TAF            = ${TAF}
1428    
1429    TAF_EXTRA      = ${TAF_EXTRA}
1430    TAMC_EXTRA     = ${TAMC_EXTRA}
1431    
1432    EOF
1433    
1434    ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
1435    ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
1436    ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
1437    for i in $ad_vars ; do
1438        name=$i
1439        t1="t2=\$"`echo $i`
1440        eval $t1
1441        printf "%-20s = " $name >> $MAKEFILE
1442        echo $t2 >> $MAKEFILE
1443    done
1444    
1445    echo "  Add the source list for AD code generation"
1446    echo >> $MAKEFILE
1447    echo -n "AD_FILES = " >> $MAKEFILE
1448    AD_FILES=`cat ad_files`
1449    for i in $AD_FILES ; do
1450        echo    " \\" >> $MAKEFILE
1451        echo -n " $i" >> $MAKEFILE
1452    done
1453    echo >> $MAKEFILE
1454    rm -f ad_files
1455    
1456    cat >>$MAKEFILE <<EOF
1457    
1458    # ... AD ...
1459    adall: ad_taf
1460    adtaf: ad_taf_output.f
1461    adtamc: ad_tamc_output.f
1462    
1463    ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1464            cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1465            @make \$(F77FILES)
1466            @make \$(AD_FLOW_FILES)
1467            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1468    
1469    ad_taf_output.f: ad_input_code.f
1470            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1471            cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f
1472    
1473    ad_taf: ad_taf_output.o \$(OBJFILES)
1474            \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1475    
1476    ad_tamc_output.f: ad_input_code.f
1477            \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
1478            cat ad_input_code_ad.f | sed -f adjoint_sed > ad_tamc_output.f
1479    
1480    ad_tamc: ad_tamc_output.o \$(OBJFILES)
1481            \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
1482    
1483    
1484    # ... FTL ...
1485    ftlall: ftl_taf
1486    ftltaf: ftl_taf_output.f
1487    ftltamc: ftl_tamc_output.f
1488    
1489    ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1490            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1491            @make \$(F77FILES)
1492            @make \$(AD_FLOW_FILES)
1493            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
1494    
1495    ftl_taf_output.f: ftl_input_code.f
1496            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1497            cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_taf_output.f
1498    
1499    ftl_taf: ftl_taf_output.o \$(OBJFILES)
1500            \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
1501    
1502    ftl_tamc_output.f: ftl_input_code.f
1503            \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
1504            cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_tamc_output.f
1505    
1506    ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
1507            \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
1508    
1509    
1510    # ... SVD ...
1511    svd: svd_taf
1512    svd_taf_f: svd_taf_output.f
1513    
1514    svd_input_code.f: \$(SRCFILES)
1515            cmp svd_config.template AD_CONFIG.h || cat svd_config.template > AD_CONFIG.h
1516            @make \$(F77FILES)
1517            @make \$(AD_FLOW_FILES)
1518            cat \$(AD_FLOW_FILES) \$(AD_FILES) > svd_input_code.f
1519    
1520    svd_taf_output.f: svd_input_code.f
1521            \$(TAF) \$(SVD_TAF_FLAGS) \$(TAF_EXTRA) svd_input_code.f
1522            cat svd_input_code_ad.f | sed -f adjoint_sed > svd_taf_output.f
1523    
1524    svd_taf: svd_taf_output.o \$(OBJFILES)
1525            \$(LINK) -o ${EXE_SVD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) svd_taf_output.o \$(LIBS)
1526    
1527    
1528    #=========================================
1529    
1530  EOF  EOF
1531    
1532  if test "x$EXEHOOK" != x ; then  if test "x$EXEHOOK" != x ; then
# Line 1173  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 1563  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
1563    
1564  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
1565    
1566    #  Write the "template" files for the adjoint builds
1567    cat >AD_CONFIG.template <<EOF
1568    C  WARNING: This file is automatically generated by genmake2 and
1569    C    used by the Makefile rules.  Please DO NOT EDIT this file
1570    C    unless you are CERTAIN that you know what you are doing.
1571    
1572    #undef ALLOW_ADJOINT_RUN
1573    #undef ALLOW_TANGENTLINEAR_RUN
1574    #undef ALLOW_ECCO_OPTIMIZATION
1575    EOF
1576    cat >ad_config.template <<EOF
1577    C  WARNING: This file is automatically generated by genmake2 and
1578    C    used by the Makefile rules.  Please DO NOT EDIT this file
1579    C    unless you are CERTAIN that you know what you are doing.
1580    
1581    #define ALLOW_ADJOINT_RUN
1582    #undef ALLOW_TANGENTLINEAR_RUN
1583    #undef ALLOW_ECCO_OPTIMIZATION
1584    EOF
1585    cat >ftl_config.template <<EOF
1586    C  WARNING: This file is automatically generated by genmake2 and
1587    C    used by the Makefile rules.  Please DO NOT EDIT this file
1588    C    unless you are CERTAIN that you know what you are doing.
1589    
1590    #undef ALLOW_ADJOINT_RUN
1591    #define ALLOW_TANGENTLINEAR_RUN
1592    #undef ALLOW_ECCO_OPTIMIZATION
1593    EOF
1594    cat >svd_config.template <<EOF
1595    C  WARNING: This file is automatically generated by genmake2 and
1596    C    used by the Makefile rules.  Please DO NOT EDIT this file
1597    C    unless you are CERTAIN that you know what you are doing.
1598    
1599    #undef ALLOW_ADJOINT_RUN
1600    #undef ALLOW_TANGENTLINEAR_RUN
1601    #undef ALLOW_ECCO_OPTIMIZATION
1602    EOF
1603    cp AD_CONFIG.template AD_CONFIG.h
1604    
1605    
1606  #  Write the "state" for future records  #  Write the "state" for future records
1607  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
1608      echo -n "" > gm_state      echo -n "" > genmake_state
1609      for i in $gm_state ; do      for i in $gm_state ; do
1610          t1="t2=\$$i"          t1="t2=\$$i"
1611          eval $t1          eval $t1
1612          echo "$i='$t2'" >> gm_state          echo "$i='$t2'" >> genmake_state
1613      done      done
1614  fi  fi

Legend:
Removed from v.1.11.2.1  
changed lines
  Added in v.1.32

  ViewVC Help
Powered by ViewVC 1.1.22